using System;

namespace Dato
{
	public class Dato
	{
		private int dag, mned, r;
		public Dato(int dag, int mned, int r) {
			this.dag = dag;
			this.mned = mned;
			this.r = r;
		}
		public int Dag {
			get {return dag;}
			set {dag = value;}
		}
		public int Mned {
			get {return mned;}
			set {mned = value;}
		}
		public int r {
			get {return r;}
			set {r = value;}
		}
		public int Kvartal {
			get {return (mned + 2) / 3;}
		}
		public string Mnedsnavn {
			get {
				switch(mned) {
					case 1: return "januar";
					case 2: return "februar";
					case 3: return "marts";
					case 4: return "april";
					case 5: return "maj";
					case 6: return "juni";
					case 7: return "juli";
					case 8: return "august";
					case 9: return "september";
					case 10: return "oktober";
					case 11: return "november";
					case 12: return "december";
					default: return "fejlagtig mned";
				}
			}
		}
		public int Dagnummer {
			get {
				int nr = 0;
				for (int i = 1; i < mned; i++) {
					nr += dageIMned(i, r);
				}
				return nr + dag;
			}
		}
		public override string ToString() {
			return dag + ". " + Mnedsnavn +" " + r;
		}
		public void NsteDato() {
			if (++dag > dageIMned(mned, r)) {
				++mned;
				dag = 1;
			}
			if (mned > 12) {
				++r;
				mned = 1;
			}
		}
		public void ForrigeDato() {
			if (--dag == 0) {
				--mned;
				if (mned == 0) {
					mned = 12;
					--r;
				}
			}
			dag = dageIMned(mned, r);
		}	
		private bool erSkudr() {
			if (r % 4 != 0)
				return false;
			else if (r % 100 == 0 && r % 400 != 0)
				return false;
			else
				return true;
		}
		private bool erSkudr(int r) {
			if (r % 4 != 0)
				return false;
			else if (r % 100 == 0 && r % 400 != 0)
				return false;
			else
				return true;
		}
		private int dageIMned() {
			switch(mned) {
				case 4:
				case 6:
				case 9:
				case 11: return 30;
				case 2:
					if (erSkudr())
						return 29;
					else
						return 28;
				default: return 31;
			}
		}
		private int dageIMned(int mned, int r) {
			switch(mned) {
				case 4:
				case 6:
				case 9:
				case 11: return 30;
				case 2:
					if (erSkudr(r))
						return 29;
					else
						return 28;
				default: return 31;
			}
		}
		private bool datoOk(int dag, int mned, int r) {
			bool ok = true;
			ok &= (r >= 0);
			ok &= (0 < mned && mned < 13);
			ok &= (0 < dag && dag <= dageIMned(mned, r));
			return ok;
		}
	}
}
